/*
 * Copyright 2013 (c) Anna Schumaker.
 */
#ifndef OCARINA_PLAYLIST_H
#define OCARINA_PLAYLIST_H

#include <playqueue.h>

#include <list>
#include <set>
#include <string>

namespace playlist
{

	void init();
	void add(const std::string &, unsigned int);
	void del(const std::string &, unsigned int);
	void select(const std::string &);
	const std::set<unsigned int> &get_tracks(const std::string &);
	Playqueue *get_pq();

#ifdef CONFIG_TEST
	void clear();
#endif /* CONFIG_TEST */
};

#endif /* OCARINA_PLAYLIST_H */
